var babel = require("@babel/core");

var LoaderError = require("./Error");

module.exports = function (source, options, cb) {
  babel.transform(source, options, function (err, result) {
    if (err) {
      return err.message && err.codeFrame ? cb(new LoaderError(err)) : cb(err);
    }

    var code = result.code,
        map = result.map,
        metadata = result.metadata;

    if (map && (!map.sourcesContent || !map.sourcesContent.length)) {
      map.sourcesContent = [source];
    }

    return cb(null, {
      code,
      map,
      metadata
    });
  });
};

module.exports.version = babel.version;